// #Лексическая область функции.

// Лексическая область функции определяет, какие переменные и имена доступны внутри функции,
// а также какие значения им присвоены.
// Обычно лексическая область создается при вызове функции и содержит все переменные, определенные в этой функции,
// а также все переменные, определенные во внешней области видимости
// (например, внутри объемлющей функции или в глобальной области видимости).

// Когда функция ищет переменную с определенным именем, она сначала проверяет свою локальную лексическую область
// (в которой была определена функция) на наличие этой переменной.
// Если переменная не найдена, то функция продолжает поиск во внешней области видимости, и так далее,
// пока переменная не будет найдена или не будет достигнута глобальная область видимости.

// Таким образом, лексическая область функции позволяет использовать и изменять значения переменных,
// которые были определены во внешней области видимости и переданы функции в качестве параметров или аргументов.

// Пример:
bool topLevel = true;
void main(){
  bool insideMain = true;
  void MyFunction(){
    bool insideMyFunction = true;
    print(topLevel); // выводим в функции MyFunction переменную topLevel и понимаем что она отображается.
    print(insideMain); // выводим в функции MyFunction переменную insideMain и понимаем что она отображается.
    print(insideMyFunction); // выводим в функции MyFunction переменную insideMyFunction и понимаем что она отображается.
  }
MyFunction();



  // #Замыкания
  // Замыкания представляют собой объект функции, которые могут запоминать и иметь доступ к переменным,
  // которые находятся вне своей лексической области видимости. Замыкание сохраняет не только код функции, 
  // но и ссылку на окружающий контекст,
  // что позволяет использовать переменные и сохранять их значения даже после завершения работы функции.

  // Пример:

  Function addFunction(num add){
    return (num i) => add + i;
  }

  var add2 = addFunction(2);
  var add4 = addFunction(4);

  print(add2(3));
  print(add4(4));

// Таким образом, замыкание позволяет сохранить и использовать состояние,
// которое существовало во время создания функции, даже после того,
// как эти значения станут недоступными во внешней области видимости.
// Это делает замыкания мощным инструментом в Dart для реализации функционального программирования,
// обработки событий и других задач, требующих сохранения состояния.


}